-module(fib_done).
-export([main/0, fibonacci/1]).

fibonacci(N) when N < 1 ->
    0;
fibonacci(1) ->
    1;
fibonacci(N) ->
    % Get our own PID, so we can send the result back to us
    Myself = self(),
    % Create reference to ensure the response we get is on our requests
    Ref = make_ref(),
    % Spawn two functions, whose purpose is to compute fibonacci and send it to us
    spawn(fun() -> Myself ! {Ref, fibonacci(N - 1)} end),
    spawn(fun() -> Myself ! {Ref, fibonacci(N - 2)} end),

    % Receive the two values. Note that, without references, it would just be
    % Res1 = receive Res_1 -> Res_1 end,
    % Res2 = receive Res_2 -> Res_2 end,
    Res1 = receive
                {Ref, Res_1} -> Res_1
           end,
    Res2 = receive
                {Ref, Res_2} -> Res_2
           end,
    
    % Last statement is always what the function returns
    Res1 + Res2.


main() ->
    Myself = self(),
    FibProc = spawn(fun() -> Myself ! fibonacci(20) end),

    % Without references, the following two messages could lead to problems! Why?
    FibProc ! 2,
    FibProc ! 3,
    receive Res -> Res end.
