-module(pingpong).
-export([main/0]).

% Simple ping function:
%   Receives a PID of the calling process,
%   Prints "ping"
%   Sends a message (its own PID) to the pong process
%   Wait for another message.
ping() ->
    receive
        From ->
            Myself = self(),
            io:fwrite("~p: ping~n", [Myself]),
            timer:sleep(1500),
            From ! Myself
    end,

    ping().

% Same as ping(), but prints "pong" instead.
pong() ->
    receive
        From ->
            Myself = self(),
            io:fwrite("~p: pong~n", [Myself]),
            timer:sleep(1500),
            From ! Myself
    end,

    pong().

main() ->
    % Spawns the processes.
    Ping = spawn(fun ping/0),
    Pong = spawn(fun pong/0),
    % Sends the PID of Pong to the Ping process to initiate the ping-pong printouts.
    Ping ! Pong.
