-module(server).
-export([main/0]).

% If we don't want to keep track of all PIDs, we can bind a PID to an atom like
% this. We can then use it when calling the process.
start_server() ->
    Pid = spawn(fun server/0),
    catch unregister(server),
    register(server, Pid).

% Initial math server, can multiply, add and subtract
server() ->
    receive
        {mul, X, Y, From} ->
            From ! {answer, X * Y};
        {add, X, Y, From} ->
            From ! {answer, X + Y};
        {sub, X, Y, From} ->
            From ! {answer, X - Y}
    end,
    server().


main() ->
    start_server(),

    % We can use the bound atom instead of a PID here
    server ! {mul, 10, 2, self()},
    receive
        Res ->
            io:fwrite("~p~n", [Res])
    end.
